from gui_canvas import Canvas
from hpprime import keyboard
import gc
from input import Input
from init import init_all_buffer_grob
from gui import Gui, IcoPreriquisite
from wr_os import open_file
from constantes import GR_DRAW
from wr_graphics import wr_time


gui_icons = [[
    "file", [
        ["new", (148,0, 37, 37), 'Gui().blank()', IcoPreriquisite.NOTHING, 2**16],
        ["load", (74,0, 37, 37), 'Gui().load()', IcoPreriquisite.NOTHING, 2**26],
        ["save", (111,0, 37, 37), 'Gui().save()', IcoPreriquisite.NOTHING, 2**16],
        ["save as", (296,0, 37, 37), 'Gui().save_as()', IcoPreriquisite.NOTHING, 2**16],
        #["save as", (185,0, 37, 37), 'Gui().select_tool("circle")', IcoPreriquisite.NOTHING, 2**16],
        # ["undo", (222,0, 37, 37), 'Gui().select_tool("circle")', IcoPreriquisite.NOTHING, 2**16],
        # ["redo", (259,0, 37, 37), 'Gui().select_tool("circle")', IcoPreriquisite.NOTHING, 2**16],
    ]],
    ["tools", [
        ["point", (74, 37, 37, 37),
         'Gui().select_tool("point")', IcoPreriquisite.NOTHING, 2**48],
        ["line", (111, 37, 37, 37),
         'Gui().select_tool("line")', IcoPreriquisite.MARK, 2**26],
        ["poly_line", (148, 37, 37, 37),
         'Gui().select_tool("polyline")', IcoPreriquisite.NOTHING, 2**31],
        ["rect", (185, 37, 37, 37),
         'Gui().select_tool("rect")', IcoPreriquisite.MARK, 2**15],
        ["circle", (222, 37, 37, 37),
         'Gui().select_tool("circle")', IcoPreriquisite.MARK, 2**16],
        # ["triangle", (259,37, 37, 37), 'Gui().select_tool("shade")', IcoPreriquisite.MARK, 2**16],
        ["fill_rect", (296, 37, 37, 37),
         'Gui().select_tool("fill_rect")', IcoPreriquisite.MARK, 2**16],
        ["fill_circle", (333, 37, 37, 37),
         'Gui().select_tool("fill_circle")', IcoPreriquisite.MARK, 2**16],
        # ["fill_triangle", (370,37, 37, 37), 'Gui().select_tool("circle")', IcoPreriquisite.MARK, 2**16],
        # ["shade_rect_bg_v", (407,37, 37, 37), 'Gui().select_tool("shade_bg_v")', IcoPreriquisite.MARK, 2**16],
        ["shade_rect_bg_h", (260, 75, 37, 37),
         'Gui().select_tool("shade_bg_h")', IcoPreriquisite.MARK, 2**16],
        # ["shade_circle", (444,37, 37, 37), 'Gui().select_tool("circle")', IcoPreriquisite.MARK, 2**16],
        # ["shade_triangle", (481,37, 37, 37), 'Gui().select_tool("circle")', IcoPreriquisite.MARK, 2**16],
        ["paint", (518,37, 37, 37), 'Gui().select_tool("fill_zone")', IcoPreriquisite.NOTHING, 2**20],
        ["shade_rect_bg_v", (555, 37, 37, 37),
         'Gui().select_tool("shade_bg_v")', IcoPreriquisite.MARK, 2**16],
        ["shade_rect_rect_p", (296, 74, 37, 37),
         'Gui().select_tool("shade_rect_p")', IcoPreriquisite.MARK, 2**16],
        ["shade_circle_p", (593, 37, 37, 37),
         'Gui().select_tool("shade_circle")', IcoPreriquisite.MARK, 2**16],
        ["text", (629, 37, 37, 37),
         'Gui().select_input_tool("text_nbg")', IcoPreriquisite.NOTHING, 2**35],
        ["fill_text", (666, 37, 37, 37),
         'Gui().select_input_tool("text")', IcoPreriquisite.NOTHING, 2**35 + 2**41],
        
    ]],
    ["function", [
        # ["rect_palette", (74,148, 37, 37), 'print("function1")', IcoPreriquisite.MARK, 2**1],
        ["circular_palette", (111,148, 37, 37), 'Gui().launch_palette(Palette().pick_edgecolor)', IcoPreriquisite.NOTHING, 2**1],
        ["circular_palette", (296, 148, 37, 37),
        'Gui().launch_palette(Palette().pick_bgcolor)', IcoPreriquisite.NOTHING, 2**6],
        # ["line_thickness", (148,148, 37, 37), 'print("function2")', IcoPreriquisite.MARK, 2**6],
        ["zoom", (185,148, 37, 37), 'Gui().launch_zoom()', IcoPreriquisite.NOTHING, 2**6],
        ["picker", (222,148, 37, 37), 'Gui().pick_color()', IcoPreriquisite.NOTHING, 2**6],
        ["transparency", (259, 148, 37, 37),'Gui().launch_transparency()', IcoPreriquisite.NOTHING, 2**6],
        ["selection", (333, 111, 37, 37),'Canvas().selection()', IcoPreriquisite.MARK, 2**6],
        ["copy", (370, 111, 37, 37),'Gui().select_tool("stamp")', IcoPreriquisite.SELECTION, 2**35],
        ["mirror_horizontal", (74, 111, 37, 37),'Gui().select_tool("mirror_hrt")', IcoPreriquisite.SELECTION, 2**6],
        ["mirror_vertical", (111, 111, 37, 37),'Gui().select_tool("mirror_vrt")', IcoPreriquisite.SELECTION, 2**6],
    ]],
    ["help", [
        ["about_help", (333,0, 37, 37), 'Gui().launch_about_help()', IcoPreriquisite.NOTHING, 2**16],
    ]],
]


def main():
    kb = 0

    gc.enable()
    init_all_buffer_grob()
    #open_file(GR_DRAW, "graphic_current_save.png")
    cv = Canvas()
    cv.fm.open_config_file()
    if cv.fm.current_file_name != "":
        print(cv.fm.current_file_name)
        open_file(GR_DRAW, cv.fm.current_file_name, cv.fm.current_app_name)
    oldkb = -1
    oldkb_time = 0
    gui = Gui()
    gui.init(gui_icons)

    input = Input()

    # The `while kb != 2**4:` is a loop that continues until the value of `kb` is equal to `2**4`
    # (which is equivalent to 16). This loop is used to continuously check for keyboard input and
    # perform actions based on the input received.
    gc_idx = 0
    while kb != 2**4:
        kb = keyboard()
        kb = -1 if kb == 0 else kb
        current_time = wr_time()
        if kb == oldkb and current_time - oldkb_time < 200:
            kb = -1
        else:
            oldkb = kb
            oldkb_time = current_time
        input.update(kb)

        #
        # Gestion de l'affichage des différentes foncionnalités
        # GR_DRAW -> GR_TMP -> GR_MARK -> GR_CURS -> GR_AFF
        #                         |->GR_GUI->|
        gui.draw()

        gc_idx += 1
        if gc_idx == 10000:
            gc_idx = 0
            gc.collect()
            gc.threshold(
                gc.mem_free() // 4 + gc.mem_alloc())


main()
