from array import *
from constantes import GR_AFF, GR_CURS, GR_DRAW, GR_LAYERS, GR_TMP
from hpprime import blit, eval
from conversion import hex_rgb
from wr_divers import add_lst


def clearGR_p(gr, w, h, c):
    wr_dimgrob_p(gr, w, h, c)
    return


def wr_dimgrob_p(gr, w, h, color):
    eval("DIMGROB_P(G" + str(gr) + "," + str(w) +
         "," + str(h) + "," + str(color) + ")")


def wr_pixon_p(gr, x1, y1, edgecolor, ca_edge):
    r, v, b = hex_rgb(edgecolor)
    eval(
        "PIXON_P(G"
        + str(gr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ","
        + "RGB("
        + str(r)
        + ","
        + str(v)
        + ","
        + str(b)
        + ","
        + str(ca_edge)
        + "))"
    )
    return gr, x1, y1, edgecolor, ca_edge


def wr_pixoff_p(gr, x1, y1):
    eval("PIXOFF_P(G" + str(gr) + "," +
         str(x1) + "," + str(y1) + ")")


def wr_rect_p(gr, x1, y1, x2, y2, edgecolor, ca_edge, fillcolor=0x0, ca_fill=255):
    r1, v1, b1 = hex_rgb(edgecolor)
    r2, v2, b2 = hex_rgb(fillcolor)
    eval(
        "RECT_P(G"
        + str(gr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ","
        + str(x2)
        + ","
        + str(y2)
        + ","
        + "rgb("
        + str(r1)
        + ","
        + str(v1)
        + ","
        + str(b1)
        + ","
        + str(ca_edge)
        + "),"
        + "rgb("
        + str(r2)
        + ","
        + str(v2)
        + ","
        + str(b2)
        + ","
        + str(ca_fill)
        + ")"
    )


def wr_arc_p(
    gr,
    x1,
    y1,
    ray1,
    ray2,
    angle_start,
    angle_end,
    edgecolor,
    ca_edge,
    fillcolor=0x0,
    ca_fill=255,
):
    r1, v1, b1 = hex_rgb(edgecolor)
    r2, v2, b2 = hex_rgb(fillcolor)
    eval(
        "ARC_P(G"
        + str(gr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ",{"
        + str(ray1)
        + ","
        + str(ray2)
        + "}"
        + ","
        + str(angle_start)
        + ","
        + str(angle_end)
        + ","
        + "{rgb("
        + str(r1)
        + ","
        + str(v1)
        + ","
        + str(b1)
        + ","
        + str(ca_edge)
        + "),"
        + "rgb("
        + str(r2)
        + ","
        + str(v2)
        + ","
        + str(b2)
        + ","
        + str(ca_fill)
        + ")})"
    )


def wr_line_p(gr, x1, y1, x2, y2, edgecolor, ca_edge):
    r1, v1, b1 = hex_rgb(edgecolor)
    eval(
        "LINE_P(G"
        + str(gr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ","
        + str(x2)
        + ","
        + str(y2)
        + ","
        + "rgb("
        + str(r1)
        + ","
        + str(v1)
        + ","
        + str(b1)
        + ","
        + str(ca_edge)
        + "))"
    )


def wr_invert_p(gr, x1, y1, x2, y2):
    eval(
        "INVERT_P(G"
        + str(gr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ","
        + str(x2)
        + ","
        + str(y2)
        + ")"
    )


def wr_triangle_p(
    gr,
    x1: int,
    y1: int,
    c1: int,
    x2: int,
    y2: int,
    c2: int,
    x3: int,
    y3: int,
    c3: int,
    ca: int,
):
    eval(
        "TRIANGLE_P(G"
        + str(gr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ","
        + str(x2)
        + ","
        + str(y2)
        + ","
        + str(x3)
        + ","
        + str(y3)
        + ","
        + str(c1)
        + ","
        + str(c2)
        + ","
        + str(c3)
        + ","
        + str(ca)
        + ")"
    )


def wr_getpix_p(gr: int, x: int, y: int) -> int:
    g = eval("GETPIX_P(G" + str(gr) +
             "," + str(x) + "," + str(y) + ")")
    return g


def wr_grobh_p():
    gh = eval("GROBH_P()")
    return gh


def wr_grobw_p():
    gw = eval("GROBW_P()")
    return gw


def wr_subgrob_p(sgr, x1, y1, x2, y2, tgr):
    sg = eval(
        "SUBGROB_P(G"
        + str(sgr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ","
        + str(x2)
        + ","
        + str(y2)
        + ",G"
        + str(tgr)
        + ")"
    )
    return sg


def wr_txtout_p(
    txt: str,
    gr: int,
    x1: int,
    y1: int,
    police: int,
    textcolor: int,
    largeur: int,
    bgcolor: int,
) -> str:
    r1, v1, b1 = hex_rgb(textcolor)
    r2, v2, b2 = hex_rgb(bgcolor)
    eval(
        'TEXTOUT_P("'
        + str(txt)
        + '",G'
        + str(gr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ","
        + str(police)
        + ",RGB("
        + str(r1)
        + ","
        + str(v1)
        + ","
        + str(b1)
        + ")"
        + ","
        + str(largeur)
        + ",RGB("
        + str(r2)
        + ","
        + str(v2)
        + ","
        + str(b2)
        + "))"
    )


def wr_txtout_nbg_p(
    txt: str, gr: int, x1: int, y1: int, police: int, textcolor: int, largeur: int
) -> str:
    r1, v1, b1 = hex_rgb(textcolor)
    eval(
        'TEXTOUT_P("'
        + str(txt)
        + '",G'
        + str(gr)
        + ","
        + str(x1)
        + ","
        + str(y1)
        + ","
        + str(police)
        + ",RGB("
        + str(r1)
        + ","
        + str(v1)
        + ","
        + str(b1)
        + ")"
        + ","
        + str(largeur)
        + ")"
    )


def wr_rotate(grt: int, angle: int, gr: int, bgcolor: int):
    r2, v2, b2 = hex_rgb(bgcolor)
    eval(
        "ROTATE("
        + str(grt)
        + ","
        + str(angle)
        + ","
        + str(gr)
        + ",RGB("
        + str(r2)
        + ","
        + str(v2)
        + ","
        + str(b2)
        + "))"
    )


def wr_graphic_to_display(gr: int, x: int, y: int, gra: int):
    blit(gr, x, y, gra)


def wr_mouse():
    return eval("mouse")


def wr_time():
    return eval("TICKS()")

# ini_f = False


"""def wr_fill_zone(gr_a: int, x: int, y: int, col_rep: int):
    # global ini_f
    p = []
    add_lst(p, x, y)
    col_c = wr_getpix_p(gr_a, x, y)
    wr_pixon_p(gr_a, x, y, col_rep, 0)
    droite, gauche, haut, bas = 0, 0, 0, 0
    # if not ini_f :
    while p != []:
        droite = wr_getpix_p(gr_a, x+1, y)
        if droite == col_c and droite != col_rep:
            add_lst(p, x+1, y)
        gauche = wr_getpix_p(gr_a, x-1, y)
        if gauche == col_c and gauche != col_rep:
            add_lst(p, x-1, y)
        haut = wr_getpix_p(gr_a, x, y+1)
        if haut == col_c and haut != col_rep:
            add_lst(p, x, y+1)
        bas = wr_getpix_p(gr_a, x, y-1)
        if bas == col_c and bas != col_rep:
            add_lst(p, x, y-1)
        y = p.pop()
        x = p.pop()
        wr_pixon_p(gr_a, x, y, col_rep, 0)
        wr_graphic_to_display(GR_AFF, 0, 0, GR_DRAW)"""

def wr_fill_zone(gr_a: int, x: int, y: int, col_rep: int):
    col_c = wr_getpix_p(gr_a, x, y)
    r1, v1, b1 = hex_rgb(col_c)
    r2, v2, b2 = hex_rgb(col_rep)
    cmd= "fill_zone(G{0},{1},{2},RGB({3},{4},{5}),RGB({6},{7},{8}))".format(gr_a, x, y, r1, v1, b1, r2, v2, b2)
    return_fill_zone = eval(cmd)
    #print(cmd)
    if return_fill_zone != 1:
        #print("Il manque le programme ppl fill_zone !")
        wr_rect_p(GR_AFF,85,95,85+165,95+40,0x0,0,0xffffff,0)
        wr_txtout_p("Vous devez installer",GR_AFF,110,100,2,0xff0000,500,0xffffff)
        wr_txtout_p("le programme ppl fill_zone !",GR_AFF,110-20,100+16,2,0xff0000,500,0xffffff)
        eval("WAIT(2)")
        return -1
    return 1
