from constantes import GR_DRAW
from hpprime import eval
from wr_os import open_file, save_file


class FilesManager():
    def __init__(self):
        self.current_file_name = ""
        self.current_app_name = ""

    @staticmethod
    def list_files(app_name):
        cmd = 'EXPR(REPLACE("'+str(app_name) + \
            '.AFiles()"," ","_"))'
        fs = eval(cmd)
        if fs is None:
            return
        fs.sort()

        def strs(x):
            if x.find(".png") > 0:
                return True
            else:
                return False

        r = filter(strs, fs)

        l1 = []

        for i in r:
            l1.append(i)

        return l1

    @staticmethod
    def list_apps():
        fs = eval('Apps()')
        fs.sort()

        return fs

    @staticmethod
    def choose_file(app_name):
        files = FilesManager.list_files(
            app_name)
        cmd = 'LOCAL a;CHOOSE(a,"' + \
            app_name+'/"'
        cmd += ',".."'
        for file in files:
            cmd += ',"' + str(file) + '"'
        cmd += ')'
        r1 = eval(cmd)
        if r1 == 1:
            return ".."
        elif r1 > 1:
            return files[int(r1) - 2]
        return None

    @staticmethod
    def choose_app():
        files = FilesManager.list_apps()
        cmd = 'LOCAL a;CHOOSE(a,"Applications",{'
        for i in range(0, len(files)):
            if i == 0:
                cmd += '"' + \
                    str(files[i]) + '"'
            else:
                cmd += ',"' + \
                    str(files[i]) + '"'
        cmd += '})'
        r1 = eval(cmd)
        if r1 > 0:
            return files[int(r1)-1]
        return None

    @staticmethod
    def chooser():
        file_name = ".."
        while file_name == "..":
            app_name = FilesManager.choose_app()
            if app_name is None:
                return None, None

            file_name = FilesManager.choose_file(
                app_name)
            if file_name is None:
                return None, None
        return app_name, file_name

    def load(self):
        app_name, file_name = FilesManager.chooser()
        if file_name is None:
            return
        open_file(
            GR_DRAW, file_name, app_name)
        self.current_file_name = file_name
        self.current_app_name = app_name

    def save_as(self):
        app_name = FilesManager.choose_app()
        if app_name is None:
            return
        file_name = input(
            "\nNom du fichier : ")
        if not file_name.endswith('.png'):
            file_name += '.png'
        save_file(
            GR_DRAW, file_name, app_name)
        self.current_file_name = file_name
        self.current_app_name = app_name
        self.save_config_file()

    def reset(self):
        self.current_file_name = ""

    def save(self):
        if self.current_file_name == "":
            self.save_as()
        else:
            save_file(
                GR_DRAW, self.current_file_name, self.current_app_name)
            self.save_config_file()

    def save_config_file(self):
        try:
            f = open("save_config_files.txt", 'w')
            f.write(self.current_app_name +
                    '/' + self.current_file_name)
            f.close()
        except FileNotFoundError as e:
            print(
                "Erreur: Le fichier n'a pas été trouvé. {}".format(e))
        except Exception as e:
            print(
                "Erreur inattendue lors de la lecture du fichier. {}".format(e))

    def open_config_file(self):
        try:
            with open("save_config_files.txt", 'r', encoding='utf-8') as fichier:
                lignes = fichier.read()
                self.current_app_name, self.current_file_name = lignes.strip().split('/')
        except FileNotFoundError as e:
            print(
                "Erreur: Le fichier n'a pas été trouvé. {e}", e)
        except Exception as e:
            print(
                "Erreur inattendue lors de la lecture du fichier. {e}", e)
